using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Windows.Forms;

namespace SimpleText
{
	public class TextPlaceWidget : Sdgt.SdgUserControl
	{
		private System.ComponentModel.IContainer components = null;
		private PointF[] TextEntryPoints = new PointF[2];
		private string[] TextBuffer = new string[2];

		public TextPlaceWidget()
		{
			// This call is required by the Windows Form Designer.
			InitializeComponent();

			// TODO: Add any initialization after the InitializeComponent call
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			// 
			// TextPlaceWidget
			// 
			this.Name = "TextPlaceWidget";
			this.SdgMouseDown += new Sdgt.SdgMouseEventHandler(this.TextPlaceWidget_SdgMouseDown);
			this.SdgKeyDown += new Sdgt.SdgKeyEventHandler(this.TextPlaceWidget_SdgKeyDown);

		}
		#endregion

		private void TextPlaceWidget_SdgKeyDown(object sender, Sdgt.SdgKeyEventArgs e) {
			if (e.KeyCode == Keys.Enter) {
				TextBuffer[e.ID] = string.Empty;
			}
			else if (e.KeyCode != Keys.ShiftKey) {
				TextBuffer[e.ID] = TextBuffer[e.ID] + (char)e.KeyValue;
			}

			Font f = new Font("Times", 12, FontStyle.Italic);
			Color c = Color.Red;

			if (e.ID > 0) {
				f = new Font("Arial", 14, FontStyle.Bold);
				c = Color.Blue;
			}

			Graphics g = this.CreateGraphics();
			g.DrawString(TextBuffer[e.ID], f, new SolidBrush(c), TextEntryPoints[e.ID]);
		}

		private void TextPlaceWidget_SdgMouseDown(object sender, Sdgt.SdgMouseEventArgs e) {
			TextEntryPoints[e.ID] = new PointF((float) e.X, (float) e.Y);
			Graphics g = this.CreateGraphics();

			if (e.ID > 0)
				g.DrawEllipse(Pens.Blue, e.X, e.Y, 2, 2);
			else
				g.DrawEllipse(Pens.Red, e.X, e.Y, 2, 2);

			TextBuffer[e.ID] = string.Empty;
		}
	}
}

